﻿Imports System.Globalization

Public Class TextEllipse
    Inherits FrameworkElement



    Public Property Text As String
        Get
            Return CType(GetValue(TextProperty), String)
        End Get

        Set(ByVal value As String)
            SetValue(TextProperty, value)
        End Set
    End Property

    Public Shared ReadOnly TextProperty As DependencyProperty =
                           DependencyProperty.Register("Text",
                           GetType(String), GetType(TextEllipse),
                           New FrameworkPropertyMetadata("", FrameworkPropertyMetadataOptions.AffectsRender, AddressOf OnTextChanged))

    Private Shared Sub OnTextChanged(ByVal d As DependencyObject, ByVal baseValue As Object)
        Dim te As TextEllipse = CType(d, TextEllipse)
        If te.GetFormattedText().Width > Double.Parse(CType(te.GetValue(DiameterProperty), String)) Then
            te.SetValue(DiameterProperty, te.GetFormattedText.Width + 30)
        End If
    End Sub
    Public Property Diameter As Double
        Get
            Return CDbl(GetValue(DiameterProperty))
        End Get

        Set(ByVal value As Double)
            SetValue(DiameterProperty, value)
        End Set
    End Property

    Public Shared ReadOnly DiameterProperty As DependencyProperty =
                           DependencyProperty.Register("Diameter",
                           GetType(Double), GetType(TextEllipse),
                           New FrameworkPropertyMetadata(Double.Parse("40"), FrameworkPropertyMetadataOptions.AffectsRender))



    Protected Overrides Sub OnRender(drawingContext As DrawingContext)
        MyBase.OnRender(drawingContext)

        drawingContext.DrawEllipse(New SolidColorBrush(Colors.Black), New Pen(New SolidColorBrush(Colors.Yellow), 2), New Point(Diameter / 2, Diameter / 2), Diameter / 2, Diameter / 2)
        Dim formatted = GetFormattedText()
        drawingContext.DrawText(formatted, New Point((Diameter - formatted.Width) / 2, (Diameter - formatted.Height) / 2))


    End Sub

    Public Function GetFormattedText() As FormattedText
        Return New FormattedText(Text, CultureInfo.InvariantCulture, FlowDirection.LeftToRight, New Typeface("Arial"), 20, New SolidColorBrush(Colors.Green), 1.25)
    End Function

End Class
